;;__PALMOS__

;;__TESTING__

MAP_LAST	EQU		12

regA		EQU		R11	;;format : 0xhhll0000 or 0xll000000
rstatus		EQU		R4  ;;format : 0xff800000
regDBank	EQU		R4	;;format : 0x000000ll
regX		EQU		R5	;;format : 0xhhll0000 or 0xll000000
regY		EQU		R6	;;format : 0xhhll0000 or 0xll000000

rpc			EQU		R7	;;32bits address
regD		EQU		R8	;;format : 0xhhll0000
regPBank	EQU		R8	;;format : 0x000000ll
regCycles	EQU		R9	;;32bits counter
regS		EQU		R10	;;format : 0x0000hhll

rscratch	EQU		R0	;;format : 0xhhll0000 if data and calculation or return of S9XREADBYTE	or WORD
regopcode	EQU		R0	;;format : 0x000000ll
rscratch2	EQU		R1	;;format : 0xhhll for calculation and value
rscratch3	EQU		R2	;;
rscratch4	EQU		R3	;;??????


rscratch5	EQU		R5	;;??????
rscratch6	EQU		R6	;;??????
rscratch7	EQU		R8	;;??????
rscratch8	EQU		R9	;;??????
rscratch9	EQU		R10	;;??????

regpcbase	EQU		R12	;;32bits address

regCPUvar   EQU		LR



;;not used
;;R13	Pointer 32 bit on a struct.

;;R15 = pc (sic!)


;;Carry       1
;;Zero        2
;;IRQ         4
;;Decimal     8
;;IndexFlag  16
;;MemoryFlag 32
;;Overflow   64
;;Negative  128
;;Emulation 256

STATUS_SHIFTER		EQU		24
MASK_EMUL			EQU		(1<<(STATUS_SHIFTER-1))
MASK_SHIFTER_CARRY	EQU		(STATUS_SHIFTER+1)
MASK_CARRY			EQU		(1<<(STATUS_SHIFTER))  ;;0
MASK_ZERO			EQU		(2<<(STATUS_SHIFTER))  ;;1
MASK_IRQ			EQU		(4<<(STATUS_SHIFTER))  ;;2
MASK_DECIMAL		EQU		(8<<(STATUS_SHIFTER))  ;;3
MASK_INDEX			EQU		(16<<(STATUS_SHIFTER)) ;;4  ;;1
MASK_MEM			EQU		(32<<(STATUS_SHIFTER)) ;;5  ;;2
MASK_OVERFLOW		EQU		(64<<(STATUS_SHIFTER)) ;;6  ;;4
MASK_NEG			EQU		(128<<(STATUS_SHIFTER));;7  ;;8

ONE_CYCLE			EQU		6
SLOW_ONE_CYCLE 		EQU		8

NMI_FLAG	    	EQU		(1 << 7)
IRQ_PENDING_FLAG    EQU		(1 << 11)
SCAN_KEYS_FLAG	    EQU		(1 << 4)


MEMMAP_BLOCK_SIZE 	EQU		(0x1000)
MEMMAP_SHIFT 		EQU		12
MEMMAP_MASK 		EQU		(0xFFF)

	END